C.----------------------------------------------------------------------
C.
C.    PHOTOS:   PHOton radiation in decays TeST program
C.
C.    Purpose:  Example of application of PHOTOS and comparison
C.              with Pythia brem.
C.
C.    Input Parameters:   None
C.
C.    Output Parameters:  None
C.
C.    Author(s):  M. Kirsanov                     Created at:  17/05/2005
C.                                                
C.----------------------------------------------------------------------
      PROGRAM MAIN
*
      IMPLICIT NONE
      integer h
      COMMON/PAWC/H(100000)
#include "pythia_strongtyp.inc"
#include "hepevt.inc"
      INTEGER PHLUN
      COMMON/PHOLUN/PHLUN
      integer iprint
      common/PRINT/iprint
*                       
*       Common block from Photos, to change parameter IEXP
*
      LOGICAL INTERF,ISEC,ITRE,IEXP,IFTOP,IFW
      REAL*8 FINT,FSEC,EXPEPS
      COMMON /PHOKEY/ FSEC,FINT,EXPEPS,INTERF,ISEC,ITRE,IEXP,IFTOP,IFW
*
      INTEGER IEVENT,NEVENT
*
      INTEGER IW,IDC,I,indzprim,nele,npho,nphodet1,nphodet2,ifdet
      real pele(3,10),ppho(3,10),cost1,cost2,sint1,sint2,sint,theta
      real PHTHRESH
      real vmod,vdot
*
* -------------------
*
*                       You can change the main parameters here:
      iprint = 1
      NEVENT=500
      PHTHRESH = 10.  ! Threshold to accept photon
*
      CALL HLIMIT(100000)
*
      CALL HBOOK1(1,'PY: number of photons',10,-0.5,9.5,0.)
      CALL HBOOK1(2,'PY: photon min theta',200,0.,2.,0.)
      CALL HBOOK1(3,'PY: photon energy',200,0.,2000.,0.)
      CALL HBOOK1(4,'PY: photon energy theta.gt.0.3',200,0.,2000.,0.)
      CALL HBOOK1(5,'PY: photon energy theta.gt.0.5',200,0.,2000.,0.)
*
      CALL HBOOK1(11,'PH: number of photons',10,-0.5,9.5,0.)
      CALL HBOOK1(12,'PH: photon min theta',200,0.,2.,0.)
      CALL HBOOK1(13,'PH: photon energy',200,0.,2000.,0.)
      CALL HBOOK1(14,'PH: photon energy theta.gt.0.3',200,0.,2000.,0.)
      CALL HBOOK1(15,'PH: photon energy theta.gt.0.5',200,0.,2000.,0.)
C--
C--   Initialise PYTHIA
      MSTP(128)=1
      MSEL=0
      MSUB(141)=1 ! Z' production
      MSTP(44) = 3 ! only Zprim, no interference with gamma, Z
      IW = PYCOMP(32) ! Zprim
      pmas(IW,1) = 4000.
      DO IDC = MDCY(IW,2), MDCY(IW,2) + MDCY(IW,3) - 1
         if(iabs(KFDP(IDC,1)).ne.11.and.              ! only electron modes
     ;      iabs(KFDP(IDC,2)).ne.11) MDME(IDC,1)=0
      ENDDO
      CALL PYINIT('CMS','P','P',14000D0)
cc      CALL PYSTAT(2)
C
C--    Event loop without Photos
C
      write(6,663) NEVENT
      nphodet1=0
      DO IEVENT=1,NEVENT
        CALL PYEVNT
C--   Write event record before emission...
        NEVHEP=IEVENT
cc        if(IEVENT.eq.1)CALL PHODMP
C--   Generate photon(s)...
cc        if(IEVENT.eq.1)CALL PHODMP
        indzprim=0
        do i=1,N
          if(k(i,2).eq.32)indzprim=i
        enddo
        if(iprint.gt.1.and.indzprim.ne.0)
     &     write(6,661) k(indzprim,5)-k(indzprim,4)+1
        nele=0
        npho=0
        do i=k(indzprim,4),k(indzprim,5)
          if(iabs(k(i,2)).eq.11) then
            nele=nele+1
            pele(1,nele)=p(i,1)
            pele(2,nele)=p(i,2)
            pele(3,nele)=p(i,3)
          endif
          if(iabs(k(i,2)).eq.22.and.p(i,4).gt.PHTHRESH) then
            npho=npho+1
            ppho(1,npho)=p(i,1)
            ppho(2,npho)=p(i,2)
            ppho(3,npho)=p(i,3)
          endif
        enddo
        if(nele.ne.2) write(6,662)
        call hfill(1,float(npho),0.,1.)
        ifdet=0
        if(npho.gt.0.and.nele.eq.2) then
          do i=1,npho
            call hfill(3,vmod(ppho(1,i),3),0.,1.)
            cost1=vdot(ppho(1,i),pele(1,1),3)/
     &              (vmod(ppho(1,i),3)*vmod(pele(1,1),3))
            if(cost1.gt.0.9999) then ! if you want to go to smaller angles
              sint1=0.               ! then double precision should be used!
            elseif(cost1.lt.0.) then
              sint1=0.99
            else
             sint1=sqrt(1.-cost1**2)
            endif
            cost2=vdot(ppho(1,i),pele(1,2),3)/
     &              (vmod(ppho(1,i),3)*vmod(pele(1,2),3))
            if(cost2.gt.0.9999) then
              sint2=0.
            elseif(cost2.lt.0.) then
              sint2=0.99
            else
             sint2=sqrt(1.-cost2**2)
            endif
            sint=sint1
            if(sint2.lt.sint1) sint = sint2
            theta=asin(sint)
            call hfill(2,theta,0.,1.)
            if(theta.gt.0.3)call hfill(4,vmod(ppho(1,i),3),0.,1.)
            if(theta.gt.0.5)call hfill(5,vmod(ppho(1,i),3),0.,1.)
            if(theta.gt.0.5.and.vmod(ppho(1,i),3).gt.30.)ifdet=1
          enddo
        endif
        if(ifdet.gt.0)nphodet1=nphodet1+1
      ENDDO
C
C--    Event loop with Photos
C
      write(6,664)
      MSTJ(41)=1 ! Switch off Pythia QED bremsshtrahlung
      CALL PHOINI ! Initialise PHOTOS
      IEXP = .TRUE.
      nphodet2=0
      DO IEVENT=1,NEVENT
        CALL PYEVNT
C--   Write event record before emission...
        NEVHEP=IEVENT
cc        if(IEVENT.eq.1)CALL PHODMP
C--   Generate photon(s)...
cc        CALL PHINTERFZ1
        call phinterfz2
cc        if(IEVENT.eq.1)CALL PHODMP
        indzprim=0
        do i=1,N
          if(k(i,2).eq.32)indzprim=i
        enddo
cc        if(indzprim.ne.0) write(6,661) k(indzprim,5)-k(indzprim,4)+1
        nele=0
        npho=0
        do i=k(indzprim,4),k(indzprim,5)
          if(iabs(k(i,2)).eq.11) then
            nele=nele+1
            pele(1,nele)=p(i,1)
            pele(2,nele)=p(i,2)
            pele(3,nele)=p(i,3)
          endif
          if(iabs(k(i,2)).eq.22.and.p(i,4).gt.PHTHRESH) then
            npho=npho+1
            ppho(1,npho)=p(i,1)
            ppho(2,npho)=p(i,2)
            ppho(3,npho)=p(i,3)
          endif
        enddo
        if(nele.ne.2) write(6,662)
        call hfill(11,float(npho),0.,1.)
        ifdet=0
        if(npho.gt.0.and.nele.eq.2) then
          do i=1,npho
            call hfill(13,vmod(ppho(1,i),3),0.,1.)
            cost1=vdot(ppho(1,i),pele(1,1),3)/
     &              (vmod(ppho(1,i),3)*vmod(pele(1,1),3))
            if(cost1.gt.0.9999) then ! if you want to go to smaller angles
              sint1=0.               ! then double precision should be used!
            elseif(cost1.lt.0.) then
              sint1=0.99
            else
             sint1=sqrt(1.-cost1**2)
            endif
            cost2=vdot(ppho(1,i),pele(1,2),3)/
     &              (vmod(ppho(1,i),3)*vmod(pele(1,2),3))
            if(cost2.gt.0.9999) then
              sint2=0.
            elseif(cost2.lt.0.) then
              sint2=0.99
            else
             sint2=sqrt(1.-cost2**2)
            endif
            sint=sint1
            if(sint2.lt.sint1) sint = sint2
            theta=asin(sint)
            call hfill(12,theta,0.,1.)
            if(theta.gt.0.3)call hfill(14,vmod(ppho(1,i),3),0.,1.)
            if(theta.gt.0.5)call hfill(15,vmod(ppho(1,i),3),0.,1.)
            if(theta.gt.0.5.and.vmod(ppho(1,i),3).gt.30.)ifdet=1
          enddo
        endif
        if(ifdet.gt.0)nphodet2=nphodet2+1
      ENDDO
C-
      write(6,665) float(nphodet1)/float(NEVENT)
      write(6,666) float(nphodet2)/float(NEVENT)
      CALL HMSTO4(2)
      STOP
661   format('number of Zprim decay products: ',i3)
662   format('less than 2 electrons!')
663   format('starting event loop without Photos, Nevents = ',i6)
664   format('starting event loop with Photos')
665   format('PYTHIA BREM: fract. of events with detectable gamma:',
     &       f5.4)
666   format('PHOTOS BREM: fract. of events with detectable gamma:',
     &       f5.4)
      END
*
      SUBROUTINE PHINTERFZ2
C.----------------------------------------------------------------------
C.
C.    PHOTOS: Interface to Pythia Z' production and lepton decay
C.
C.    Purpose: Convert PYTHIA event record to HEPEVT, find last Z'
C.             call PHOTOS on it to make make QED corrections
C.             (emit photon(s)), put everything back to PYJETS.
C.             This will work only with PYTHIA's MSTP(128)=1 (default 0)
C.
C.    Input Parameters:   Common /PYJETS/
C.
C.    Output Parameters:  Common /HEPEVT/
C.
C.    Author(s):  M. Kirsanov                     Created at:  17/05/2005
C.
C.----------------------------------------------------------------------
      IMPLICIT NONE

#include "pythia_strongtyp.inc"
#include "hepevt.inc"
      integer iprint
      common/PRINT/iprint
      integer nprinted
      INTEGER I,NZ,J,N_OLD,N_NEW,LZ(2),IZ,IPD1,IPD2,JP1,JP2
      INTEGER    NHEP_BEF_PHOTOS,NHEP_AFT_PHOTOS
      INTEGER NHEPORI,I_PARENT,KF_PARENT,KF_CODE,IFIRSTNEW,N21
      INTEGER NCOM,NNOCOM,KTEMP(4000,5)
      REAL PTEMP(4000,5),VTEMP(4000,5)
      data nprinted/0/
      NHEPORI = N
*
*         Zero HEPEVT and Pythia arrays
*
      NHEP = 0
      CALL VZERO (ISTHEP,   NMXHEP)
      CALL VZERO (IDHEP,    NMXHEP)
      CALL VZERO (JMOHEP, 2*NMXHEP)
      CALL VZERO (JDAHEP, 2*NMXHEP)
      CALL VZERO (PHEP,5*NMXHEP*2)    ! Note: double precision
      CALL VZERO (VHEP,4*NMXHEP*2)
*
      call pyhepc(1)
*
      iz=0
      do i=1,nhep
       if(idhep(i).eq.32)iz=i
      enddo
*
      NHEP_BEF_PHOTOS=NHEP
cc      CALL PHOTOS(1) ! will not work like this: particle 1 has no daughters
      if(iz.gt.0)CALL PHOTOS(iz)
      if(iz.eq.0)write(*,*)'no Z'!!!!!!!!!!!!!!!'
      NHEP_AFT_PHOTOS=NHEP
      IF(iprint.gt.1.and.NHEP_BEF_PHOTOS.NE.NHEP_AFT_PHOTOS)
     &     WRITE(*,*) NHEP_AFT_PHOTOS-NHEP_BEF_PHOTOS,
     &     ' NEW PARTICLES FROM PHOTOS IN Zprim DECAY!!!',
     &     NHEP_BEF_PHOTOS,NHEP_AFT_PHOTOS,IDHEP(1)

      IF(NHEP_AFT_PHOTOS.GT.NHEP_BEF_PHOTOS)THEN  ! --- actions if generated -

        if(iprint.gt.1) call pylist(5)
        if(iprint.eq.1) then
          if(nprinted.eq.0) then
            call pylist(5)
            nprinted = nprinted + 1
          endif
        endif

        call pyhepc(2)

      ENDIF
      END
*
*
      SUBROUTINE PHINTERFZ1
C.----------------------------------------------------------------------
C.
C.    PHOTOS: Interface to Pythia Z' production and lepton decay
C.
C.    Purpose: Take Z' and its decay products, put "manually" in HEPEVT, make
C.             QED corrections (emit photon(s)), put everything back to PYJETS.
C.             The point is that Photos does not understand PYTHIA event
C.             record with INFO lines in the PYTHIA default mode MSTP(128)=0
C.
C.    Input Parameters:   Common /PYJETS/
C.
C.    Output Parameters:  Common /HEPEVT/
C.
C.    Author(s):  M. Kirsanov                     Created at:  17/05/2005
C.
C.----------------------------------------------------------------------
      IMPLICIT NONE

#include "pythia_strongtyp.inc"
#include "hepevt.inc"
      integer iprint
      common/PRINT/iprint

      integer nprinted
      INTEGER I,NZ,J,N_OLD,N_NEW,LZ(2),IZ,IPD1,IPD2,JP1,JP2
      INTEGER    NHEP_BEF_PHOTOS,NHEP_AFT_PHOTOS
      INTEGER NHEPORI,I_PARENT,KF_PARENT,KF_CODE,IFIRSTNEW,N21
      INTEGER NCOM,NNOCOM,KTEMP(4000,5)
      REAL PTEMP(4000,5),VTEMP(4000,5)
      data nprinted/0/
*
*       Perform Z' decays allowing for radiation using PHOTOS, as follows:
*       ------------------------------------------------------------------------
*
*       1.  clear HEPEVT common (which contains full event)
*       2.  copy two Z's and decay products (4 leptons) into HEPEVT common
*       3.  allow PHOTOS to deal with the radiation in Z decays
*       4.  move "new leptons" and photons to (empty) end of PYJETS
*       5.  flag original leptons in PYJETS as "documentation" and
*           update pointers to and from modified leptons and new photons
*
*       Steps 6 to 10 carried out only if one or both Zs have decayed to taus:
*       6.  clear HEPEVT common
*       7.  copy taus and their decay products (1 charged lepton plus 2
*           neutrinos for each tau) into HEPEVT common
*       8.  allow PHOTOS to deal with the radiation in tau decays
*       9.  move new tau decay products and photons to (empty) end of PYJETS
*       10. flag original tau decay products in PYJETS as "documentation" and
*           update pointers to and from modified tau decay products and new
*           photons
*
*       11. fill HEPEVT common with (modified) full event
*
*
      NHEPORI = N
*
*         Zero HEPEVT and Pythia arrays
*
      NHEP = 0
      CALL VZERO (ISTHEP,   NMXHEP)
      CALL VZERO (IDHEP,    NMXHEP)
      CALL VZERO (JMOHEP, 2*NMXHEP)
      CALL VZERO (JDAHEP, 2*NMXHEP)
      CALL VZERO (PHEP,5*NMXHEP*2)    ! Note: double precision
      CALL VZERO (VHEP,4*NMXHEP*2)
*
*       Fill Z' decay products into HEPEVT common
*       ----------------------------------------
*
      NZ = 0
*
      DO I=1,N
*
        IF(K(I,1) .EQ. 11 .AND. K(I,2) .EQ. 32) THEN    ! This is a Z'
*
          NZ           = NZ + 1
*
          IF (NZ .GT. 1) THEN
            WRITE (*,*) '**KIS_HEAVYNU** Error: >1 Z''s in event!'
            STOP '=> FORTRAN STOP'
          ENDIF
*
          NEVHEP       = 0              ! Event number (unused)
          NHEP         = 3              ! No. of particles to go in HEPEVT
*
          IPD1         = K (I,4)        ! Index of 1st  daughter of Z'
          IPD2         = K (I,5)        ! Index of last daughter of Z'

*
          JP1          = 2              ! Offset in HEPEVT of 1st  daughter
          JP2          = 3              ! Offset in HEPEVT of last daughter
*
          ISTHEP (NZ)  = 2              ! \ Do not end line with a backslash!
          ISTHEP (JP1) = 1              !  }-   Status codes
          ISTHEP (JP2) = 1              ! /
*
          IDHEP  (NZ)  = K (I,   2)     ! \ Do not end line with a backslash!
          IDHEP  (JP1) = K (IPD1,2)     !  }-   KF codes
          IDHEP  (JP2) = K (IPD2,2)     ! /
*
          JMOHEP (1,NZ)  = 0            ! 1st mother of Z (none)
          JMOHEP (2,NZ)  = 0            ! 2nd mother of Z (none)
          JMOHEP (1,JP1) = NZ           ! 1st mother of lepton
          JMOHEP (2,JP1) = 0            ! 2nd mother of lepton
          JMOHEP (1,JP2) = NZ           ! 1st mother of lepton
          JMOHEP (2,JP2) = 0            ! 2nd mother of lepton
*
          JDAHEP (1,NZ)  = JP1          ! 1st daughter of Z
          JDAHEP (2,NZ)  = JP2          ! 2nd daughter of Z
          JDAHEP (1,JP1) = 0            ! 1st daughter of lepton
          JDAHEP (2,JP1) = 0            ! 2nd daughter of lepton
          JDAHEP (1,JP2) = 0            ! 1st daughter of lepton
          JDAHEP (2,JP2) = 0            ! 2nd daughter of lepton
*
          DO J=1,5
            PHEP (J,NZ)  = P (I,J)
            PHEP (J,JP1) = P (IPD1,J)
            PHEP (J,JP2) = P (IPD2,J)
          ENDDO
*
*
          DO J=1,4
            VHEP (J,NZ)  = V (I,J)
            VHEP (J,JP1) = V (IPD1,J)
            VHEP (J,JP2) = V (IPD2,J)
          ENDDO
*
        ENDIF
*
      ENDDO
*
*       Call PHOTOS to generate radiation in Z' decay
*       --------------------------------------------
*
      NHEP_BEF_PHOTOS=NHEP
      CALL PHOTOS (1)

      NHEP_AFT_PHOTOS=NHEP
      IF(iprint.gt.1.and.NHEP_BEF_PHOTOS.NE.NHEP_AFT_PHOTOS)
     &     WRITE(*,*) NHEP_AFT_PHOTOS-NHEP_BEF_PHOTOS,
     &     ' NEW PARTICLES FROM PHOTOS IN Zprim DECAY!!!',
     &     NHEP_BEF_PHOTOS,NHEP_AFT_PHOTOS,IDHEP(1)

      IF(NHEP_AFT_PHOTOS.GT.NHEP_BEF_PHOTOS)THEN  ! --- actions if generated -

        if(iprint.gt.1) call pylist(5)
        if(iprint.eq.1) then
          if(nprinted.eq.0) then
            call pylist(5)
            nprinted = nprinted + 1
          endif
        endif
*
*         Original leptons still in PYJETS => flag lines as documentation only
*         --------------------------------------------------------------------
*
        DO I = 1,N
          IF(K(I,1).EQ.1) THEN
*
            I_PARENT  = K(I,3)
            KF_PARENT = IABS (K(I_PARENT,2)) ! KF code of the parent
            KF_CODE   = IABS (K(I,2)) ! KF code of the particle
*
*           Need to flag ORIGINAL leptons as documentation lines
*           (the parents of these are ALSO leptons (due to Pythia convention),
*           the parents of THESE are then the Z!)
*
            IF( (KF_CODE .EQ. 11  .AND. KF_PARENT .EQ. 11) ) THEN
              K(I,1) = 21                       ! flag as documentation line
            ENDIF
*
          ENDIF
        ENDDO
*
*
*         Count Z's in the event and save the corresponding indices
*         ---------------------------------------------------------
*
        NZ=0
*
        DO I = 1,N
          IF(K(I,1).EQ.11 .AND. K(I,2) .EQ. 32) THEN  ! Save index to Z'
*
            NZ      = NZ + 1
            LZ (NZ) = I
*
          ENDIF
        ENDDO
*
*
*         Copy leptons and any extra photons back into PYJETS
*         ---------------------------------------------------
*
        N_OLD = N
        N_NEW = N
*
        DO I=1,NHEP
*
          KF_CODE = IABS (IDHEP(I))
*
          IF( KF_CODE .EQ. 11 .OR.
     &        KF_CODE .EQ. 22) THEN
*
            N_NEW  = N_NEW + 1
*
            K (N_NEW,1) = 1
            K (N_NEW,2) = IDHEP(I)
            K (N_NEW,3) = LZ(1)
            K (N_NEW,4) = 0
            K (N_NEW,5) = 0
*
*
            DO J=1,5
              P (N_NEW,J) = PHEP(J,I)
            ENDDO
*
            DO J=1,4
              V (N_NEW,J) = VHEP(J,I)
            ENDDO
*
          ENDIF
        ENDDO
*
*         Point last daughters of Z's to the "new" leptons/photons
*         --------------------------------------------------------
*
        DO IZ = 1,NZ                        ! Loop over Z's
          DO I = N_OLD+1, N_NEW             ! Loop over "extra" particles
*
            IF(K(I,3) .EQ. LZ(IZ)) THEN     ! Parent is Z
              K(LZ(IZ),5) = I               ! Set "last daughter" of Z
            ENDIF
*
          ENDDO
        ENDDO
*
*
*         Point first daughters of Z's to the "new" leptons/photons
*         ---------------------------------------------------------
*
        K(LZ(1),4) = N_OLD      + 1 ! 1st "extra particle"
*
*
        N = N_NEW                   ! New no. of particles in PYJETS
        IFIRSTNEW = N_OLD+1

***** Put all the '21' particles first

        N21 = 0
        DO I=1,NHEPORI
          IF(K(I,1).EQ.21) N21 = N21 + 1
        ENDDO
        NCOM = 0
        NNOCOM = N21
        DO I=1,NHEPORI
*
          IF(K(I,1).EQ.21) THEN
            NCOM = NCOM + 1
            N_NEW = NCOM
          ELSE
            NNOCOM = NNOCOM + 1
            N_NEW = NNOCOM
          ENDIF
          DO J=1,5
            KTEMP(N_NEW,J) = K(I,J)
            PTEMP(N_NEW,J) = P(I,J)
            VTEMP(N_NEW,J) = V(I,J)
          ENDDO
*
        ENDDO

        DO I=1,NHEPORI
*
          DO J=1,5
            K(I,J) = KTEMP(I,J)
            P(I,J) = PTEMP(I,J)
            V(I,J) = VTEMP(I,J)
          ENDDO
*
        ENDDO
*
****** Restore correct mother after reordering above
*
        IF(NHEP_AFT_PHOTOS.GT.NHEP_BEF_PHOTOS)THEN
          DO I = 1,N
            IF(K(I,1).EQ.11 .AND. K(I,2) .EQ. 32) THEN  ! Save index to Z'
              LZ (1) = I
            ENDIF
          ENDDO
          DO I = IFIRSTNEW, N
            K (I,3) = LZ(1)
          ENDDO
        ENDIF

      ENDIF  !  ---------  end of actions in case of photons generarion

*       Re-fill HEPEVT common with FULL event from PYJETS
*       -------------------------------------------------

      CALL PYHEPC(1)
*
      RETURN
      END
*
*
      SUBROUTINE HMSTO4(LUNH)  
C.    * 
C.    *  STORES HISTOGRAMS ON DISK, CANAL LUNH
C.    * 
      DATA IWRIT/0/
      IF(IWRIT.LE.0)CALL HROPEN(LUNH,'M','hist.dat',' N',1024,IOK)
      IF(IWRIT.GT.0)CALL HROPEN(LUNH,'M','hist.dat','  ',1024,IOK)
      CALL HROUT(0,ICICLE,' ')
      CALL HREND('M')
      CLOSE (LUNH)   
      IWRIT=IWRIT+1
      RETURN
      END
